commit 60b1511aee0989d251562336bc0fbabc8b841d95
Author: David Davis <daviddavis@redhat.com>
Date:   Thu Jun 8 19:15:10 2017 +0000

    Fixes #19759 - Add options to skip publish and promote

diff --git a/lib/hammer_cli_csv/content_views.rb b/lib/hammer_cli_csv/content_views.rb
index 3de91c4..e4a888a 100644
--- a/lib/hammer_cli_csv/content_views.rb
+++ b/lib/hammer_cli_csv/content_views.rb
@@ -9,6 +9,10 @@ module HammerCLICsv
       command_name 'content-views'
       desc         'import or export content-views'
 
+      option %w(--[no-]publish), :flag, _('Publish content view on import (default false)')
+      option %w(--[no-]promote), :flag,
+        _('Publish and promote content view on import (default false)')
+
       LABEL = 'Label'
       ORGANIZATION = 'Organization'
       DESCRIPTION = 'Description'
@@ -17,6 +21,10 @@ module HammerCLICsv
       ENVIRONMENTS = "Lifecycle Environments"
 
       def export(csv)
+        if (options.keys & %w(option_promote option_publish)).any?
+          fail _("Cannot pass publish or promote options on export")
+        end
+
         csv << [NAME, LABEL, ORGANIZATION, COMPOSITE, REPOSITORIES, ENVIRONMENTS]
         @api.resource(:organizations).call(:index, {
             :per_page => 999999,
@@ -58,6 +66,10 @@ module HammerCLICsv
       end
 
       def import
+        if options.keys.include?('option_publish') && !option_publish? && option_promote?
+          fail _("Cannot pass in --promote with --no-publish")
+        end
+
         @existing_contentviews = {}
 
         thread_import do |line|
@@ -97,7 +109,7 @@ module HammerCLICsv
 
           contentview_id = @existing_contentviews[line[ORGANIZATION]][name]
           if !contentview_id
-            print _("Creating content view '%{name}'...") % {:name => name} if option_verbose?
+            puts _("Creating content view '%{name}'...") % {:name => name} if option_verbose?
             options = {
                 'organization_id' => foreman_organization(:name => line[ORGANIZATION]),
                 'name' => name,
@@ -108,7 +120,7 @@ module HammerCLICsv
             contentview_id = @api.resource(:content_views).call(:create, options)['id']
             @existing_contentviews[line[ORGANIZATION]][name] = contentview_id
           else
-            print _("Updating content view '%{name}'...") % {:name => name} if option_verbose?
+            puts _("Updating content view '%{name}'...") % {:name => name} if option_verbose?
           end
 
           options = {
@@ -123,13 +135,15 @@ module HammerCLICsv
           contentview = @api.resource(:content_views).call(:update, options)
           contentview_id = contentview['id']
 
-          # Content views cannot be used in composites unless a publish has occurred
-          if contentview['versions'].empty? && !line[ENVIRONMENTS].empty?
-            publish_content_view(contentview_id, line)
-          end
+          if option_publish? || option_promote?
+            # Content views cannot be used in composites unless a publish has occurred
+            if contentview['versions'].empty? && !line[ENVIRONMENTS].empty?
+              publish_content_view(contentview_id, line)
+            end
 
-          unless line[ENVIRONMENTS].empty?
-            promote_content_view(contentview_id, line)
+            if !line[ENVIRONMENTS].empty? && option_promote?
+              promote_content_view(contentview_id, line)
+            end
           end
 
           puts _('done') if option_verbose?
diff --git a/test/csv_test_helper.rb b/test/csv_test_helper.rb
index 2e4471e..51b4eef 100644
--- a/test/csv_test_helper.rb
+++ b/test/csv_test_helper.rb
@@ -108,7 +108,7 @@ def host_delete(hostname)
   end
 end
 
-def content_view_delete(name)
+def content_view_delete(name, environments="Library")
   org = 'Test Corporation'
   id = nil
   stdout,stderr = capture {
@@ -121,7 +121,7 @@ def content_view_delete(name)
 
   if id
     stdout,stderr = capture {
-      hammer.run(%W(content-view remove --id #{id} --organization #{org} --environments Library))
+      hammer.run(%W(content-view remove --id #{id} --organization #{org} --environments #{environments}))
     }
 
     stdout,stderr = capture {
diff --git a/test/resources/content_views_test.rb b/test/resources/content_views_test.rb
index 44c634a..828020e 100644
--- a/test/resources/content_views_test.rb
+++ b/test/resources/content_views_test.rb
@@ -18,6 +18,8 @@ Usage:
      csv content-views [OPTIONS]
 
 Options:
+ --[no-]promote                Publish and promote content view on import (default false)
+ --[no-]publish                Publish content view on import (default false)
  --continue-on-error           Continue processing even if individual resource error
  --export                      Export current data instead of importing
  --file FILE_NAME              CSV file (default to /dev/stdout with --export, otherwise required)
@@ -43,16 +45,16 @@ HELP
       stdout,stderr = capture {
         hammer.run(%W{--reload-cache csv content-views --verbose --file #{file.path}})
       }
-      refute_equal '', stderr
-      assert_equal stdout[0..-2], "Creating content view '#{name}'...done"
+      assert_equal '', stderr # no task
+      assert_equal stdout[0..-2], "Creating content view '#{name}'...\ndone"
 
       file.rewind
 
       stdout,stderr = capture {
         hammer.run(%W{--reload-cache csv content-views --verbose --file #{file.path}})
       }
-      assert_equal '', stderr
-      assert_equal stdout[0..-2], "Updating content view '#{name}'...done"
+      assert_equal '', stderr # no task
+      assert_equal stdout[0..-2], "Updating content view '#{name}'...\ndone"
       file.unlink
 
       stdout,stderr = capture {
@@ -65,6 +67,123 @@ HELP
       stop_vcr
     end
 
+    def test_import_no_publish
+      start_vcr
+      set_user 'admin'
+
+      name = "testcv1"
+
+      file = Tempfile.new('content_views_test')
+      file.write("Name,Label,Organization,Composite,Repositories or Composites,Lifecycle Environments\n")
+      file.write("#{name},#{name},Test Corporation,No,"",Library\n")
+      file.rewind
+
+      stdout,stderr = capture {
+        hammer.run(%W{--reload-cache csv content-views --verbose --file #{file.path} --no-publish})
+      }
+      assert_equal '', stderr # no task
+      assert_equal stdout[0..-2], "Creating content view '#{name}'...\ndone"
+
+      stdout,stderr = capture {
+        hammer.run(%W{--reload-cache content-view version list --organization-label testcorp --content-view #{name}})
+      }
+      versions = stdout.split("\n").length - 3
+      assert_equal 0, versions
+
+      file.unlink
+      content_view_delete(name)
+      stop_vcr
+    end
+
+    def test_import_publish
+      start_vcr
+      set_user 'admin'
+
+      name = "testcv1"
+
+      file = Tempfile.new('content_views_test')
+      file.write("Name,Label,Organization,Composite,Repositories or Composites,Lifecycle Environments\n")
+      file.write("#{name},#{name},Test Corporation,No,"",Library\n")
+      file.rewind
+
+      stdout,stderr = capture {
+        hammer.run(%W{--reload-cache csv content-views --verbose --file #{file.path} --publish})
+      }
+      assert_match(/Task .* running/, stderr)
+      assert_equal stdout[0..-2], "Creating content view '#{name}'...\ndone"
+
+      stdout,stderr = capture {
+        hammer.run(%W{--reload-cache content-view version list --organization-label testcorp --content-view #{name}})
+      }
+      versions = stdout.split("\n").length - 4
+      assert_equal 1, versions
+
+      stdout,stderr = capture {
+        hammer.run(%W{--reload-cache content-view info --organization-label testcorp --name #{name}})
+      }
+      environment = stdout[/Lifecycle Environments:(.*)Versions/m, 1].strip.split("\n")
+      assert_equal 1, environment.length / 2 # environment contains two lines (id and name)
+      assert_match(/Library/, environment.last)
+
+      file.unlink
+      content_view_delete(name)
+      stop_vcr
+    end
+
+    def test_import_promote_no_publish
+      start_vcr
+      set_user 'admin'
+
+      name = "testcv1"
+
+      file = Tempfile.new('content_views_test')
+      file.write('')
+      file.rewind
+
+      stdout,stderr = capture {
+        hammer.run(%W{--reload-cache csv content-views --verbose --file #{file.path} --promote --no-publish})
+      }
+      assert_match(/Cannot pass in --promote with --no-publish/, stderr)
+
+      file.unlink
+      stop_vcr
+    end
+
+    def test_import_promote
+      start_vcr
+      set_user 'admin'
+
+      name = "testcv1"
+
+      file = Tempfile.new('content_views_test')
+      file.write("Name,Label,Organization,Composite,Repositories or Composites,Lifecycle Environments\n")
+      file.write("#{name},#{name},Test Corporation,No,"",\"Library,Development\"\n")
+      file.rewind
+
+      stdout,stderr = capture {
+        hammer.run(%W{--reload-cache csv content-views --verbose --file #{file.path} --promote})
+      }
+      assert_match(/Task .* running/, stderr)
+      assert_equal stdout[0..-2], "Creating content view '#{name}'...\ndone"
+
+      stdout,stderr = capture {
+        hammer.run(%W{--reload-cache content-view version list --organization-label testcorp --content-view #{name}})
+      }
+      versions = stdout.split("\n").length - 4
+      assert_equal 1, versions
+
+      stdout,stderr = capture {
+        hammer.run(%W{--reload-cache content-view info --organization-label testcorp --name #{name}})
+      }
+      environment = stdout[/Lifecycle Environments:(.*)Versions/m, 1].strip.split("\n")
+      assert_equal 2, environment.length / 2 # environment contains two lines (id and name)
+      assert_match(/Development/, environment.last)
+
+      file.unlink
+      content_view_delete(name, "Library,Development")
+      stop_vcr
+    end
+
     def test_export
       start_vcr
       set_user 'admin'
@@ -76,6 +195,23 @@ HELP
       assert_equal stdout.split("\n")[0], "Name,Label,Organization,Composite,Repositories or Composites,Lifecycle Environments"
       stop_vcr
     end
+
+    def test_export_promote_publish
+      start_vcr
+      set_user 'admin'
+
+      _, stderr = capture {
+        hammer.run(%W{--reload-cache csv content-views --export --organization Test\ Corporation --promote})
+      }
+      assert_match(/Cannot pass publish or promote options on export/, stderr)
+
+      _, stderr = capture {
+        hammer.run(%W{--reload-cache csv content-views --export --organization Test\ Corporation --publish})
+      }
+      assert_match(/Cannot pass publish or promote options on export/, stderr)
+
+      stop_vcr
+    end
   end
 end
 # rubocop:enable LineLength
